turf
	var
		nonpathable=0
	proc
		GetAdjacentTurfs()      //gets the adjacent turfs, excluding diaganols.
			var/L[]=new()
			for(var/turf/t in oview(src,1))
				if(t.x>src.x&&t.y>src.y)
					continue
				if(t.x>src.x&&t.y<src.y)
					continue
				if(t.x<src.x&&t.y>src.y)
					continue
				if(t.x<src.x&&t.y<src.y)
					continue
				if(!t.nonpathable&&!t.dense)
					L.Add(t)
			return L
		BigGetAdjacentTurfs()
			var/L[]=new()
			var/turf/east=locate(src.x+1,src.y,src.z)
			var/turf/west=locate(src.x-1,src.y,src.z)
			var/turf/north=locate(src.x,src.y+1,src.z)
			var/turf/south=locate(src.x,src.y-1,src.z)
			if(east&&!east.nonpathable)
				var/turf/a=locate(east.x+1,east.y,east.z)
				var/turf/b=locate(east.x+1,east.y+1,east.z)
				var/turf/c=locate(east.x,east.y+1,east.z)
				if(a&&b&&c)
					if(!a.nonpathable&&!b.nonpathable&&!c.nonpathable)
						L.Add(east)
			if(west&&!west.nonpathable)
				var/turf/a=locate(west.x,west.y+1,west.z)
				if(a&&!a.nonpathable)
					L.Add(west)
			if(north&&!north.nonpathable)
				var/turf/a=locate(north.x+1,north.y,north.z)
				var/turf/b=locate(north.x+1,north.y+1,north.z)
				var/turf/c=locate(north.x,north.y+1,north.z)
				if(a&&b&&c&&!a.nonpathable&&!b.nonpathable&&!c.nonpathable)
					L.Add(north)
			if(south&&!south.nonpathable)
				var/turf/a=locate(south.x+1,south.y,south.z)
				var/turf/b=locate(south.x+1,south.y-1,south.z)
				var/turf/c=locate(south.x,south.y-1,south.z)
				if(a&&b&&c&&!a.nonpathable&&!b.nonpathable&&!c.nonpathable)
					L.Add(south)
			return L
		GetDistance(turf/t)       //gets distance to and from turfs (there are no pathweights)
			if(get_dist(src,t)==1)
				var/cost=(src.x-t.x)*(src.x - t.x)+(src.y - t.y)*(src.y - t.y)
				return cost
			else
				return get_dist(src,t)
