world
	view = 5
	mob = /mob/player
	New()
		..()

var/n_count = 0

mob
	icon = 'mobs.dmi'
	player
		de_pin_icon = 'Demo/pins.dmi'//pins icon
		de_pin_icon_state = "player"//pins icon_state
		icon_state = "player"
		Stat()
			..()
			statpanel("Server")
			stat("CPU:","[world.cpu]")
			stat("NPC:","[n_count]")
			stat("X,Y,Z:","[src.x],[src.y],[src.z]")
		Login()
			..()
			src.loc = locate(1,1,1)
			src.de_create_pin() // create my pin
		verb/Hide()
			set name = "Hide/Show_Layout"
			if(src.de_map_is_up)
				src.de_map_is_up = 0
				src.de_update_map_layout(1)
				if(winget(src, "mini_map","is-visible") == "true")
					winshow(src, "mini_map",0)
			else
				src.de_map_is_up = 1
				src.de_update_map_layout()
				winshow(src, "mini_map",1)
		verb/Delete_All_Mobs()
			for(var/mob/zombie/Z in world)
				if(!Z) continue
				del(Z)
		verb/Create_Mobs()
			var/list/rand_spawn = new/list()
			for(var/turf/T in world)
				if(!T||T.density) continue
				if(prob(10))
					rand_spawn += T
			if(length(rand_spawn))
				var/count = rand(100,300)
				while(count--)
					var/turf/R = pick(rand_spawn)
					new/mob/zombie(R)
	zombie
		de_pin_enable = 1//enable the pin creation for this mob.
		de_pin_icon = 'Demo/pins.dmi'//pins icon
		de_pin_icon_state = "zombie"//pins icon_state

		icon_state = "zombie"
		New()
			n_count++
			..()
			spawn() src.AI()
		Del()
			n_count--
			..()
		proc/AI()
			step_rand(src)
			spawn(rand(5,25))
				src.AI()

turf
	icon = 'Demo/turfs.dmi'
	water
		icon_state = "water"
		density = 1
	ground
		icon_state = "ground"
	grass
		icon_state = "grass"
	stairs
		var
			nx = 0
			ny = 0
			nz = 0
		icon_state = "stairs"
		Entered(atom/movable/a)
			..()
			if(nx && ny && nz)
				var/turf/T = locate(nx,ny,nz)
				if(T) a.Move(T)


obj/other_ways//another way to create pins for special places.
	stairs
		de_pin_enable = 1
		de_pin_icon = 'Demo/pins.dmi'
		de_pin_icon_state = "stairs"