//returns an assoc. list of attributes and values in the format, "[start_pos]" = end_pos
proc/_get_in_tag_words(t)
	ASSERT(istext(t))
	var/list/result
	var/pos = 1
	var/next_space_pos = findtext(t," ",pos)
	while(pos)
		if(pos == 1)
			//if the tag is attribute-less
			if(!next_space_pos) return
			//Skip the tag word itself
			pos += length(copytext(t,1,next_space_pos + 1))
			continue
		else next_space_pos = findtext(t," ",pos + 1)
		if(!result) result = list()
		if(next_space_pos)
			result["[pos]"] = next_space_pos - 1
			pos = next_space_pos
		else result["[pos]"] = length(t)
		if(!next_space_pos && result && result.len) return result