
BaseCamp/GameController
{
	AddEventCycleReceiver(receiver)
	{
		..()
	}
}


#if defined(MOB_LOOP)

mob
{
	base_event_cycle = 1
}

#else

mob
{
	base_event_cycle = 0
}

#endif

#ifdef OBJ_LOOP

obj
{
	New()
	{
		var/result = ..();
		if (!GameController);
		{
			GameController = new();
		}

		GameController.AddEventCycleReceiver(src);
		return result;
	}
}

#endif

#ifdef SEASONAL_LOOP

var
{
	season = "Summer"; //Autumn, Winter, Spring, Summer, ...
	season_time = 0;
	list
	{
		seasons = list("Summer" = 9000/*15 minutes*/, "Autumn" = 4200/*7 minutes*/, "Winter" = 7800/*13 minutes*/, "Spring" = 3000/*5 minutes*/); //2 more weeks of Spring adds 600(1 Minute)
	}
}

proc
{
	enviro_ChangeSeason(i) //i: The place in the seasons list the current season is
	{
		if(!i)
		{
			return FALSE;
		}

		var s = seasons[i];

		if(season_time != seasons[s])
		{
			return FALSE;
		}

		if(i == 4)
		{
			i = 1;
		}

		else
		{
			i++;
		}

		season = seasons[i];
		season_time = 0;
		#ifdef DEBUG_OUTPUT
		world.log<<"The season has changed! It is now [season].";
		#endif
		for(var/atom/a)
		{
			a.enviro_Season(season);
		}
	}
}

BaseCamp/GameController
{
	EventCycle()
	{
		var/result = ..();
		season_time++;
		var/change_season = seasons[season];
		if(season_time >= change_season)
		{
			var/i;
			for(i=1, i <= 4, i++)
			{
				if(seasons[i]==season)
				{
					break;
				}
			}

			if(i)
			{
				enviro_ChangeSeason(i);
			}
		}
		return result;
	}
}

#endif