/*
ATTENTION

Do not alter the following code unless you know what you are doing (or at least think you know!)*/

proc

	C_Pixel_Map_Check(atom/a)                   //ensures you stay on the map
		var/maptop=(world.maxx*32)              //defines where the topmost pixel of the map is
		var/mapright=(world.maxy*32)            //defines where the furthest right pixel of the map is
		if(a.x_min<=0||a.y_min<=0)              //if your bounding box attempts to go below the y or x axis of the map stop it
			a.can_move=0
		if(a.x_max>maptop||a.y_max>mapright)    //if your bounding box attempts to go above or to the right of the map stop it
			a.can_move=0

	C_Pixel_Mob_Handling(atom/movable/a)         //shifts your mob as necessary
		if(a.x_shifts>=32)                       //if the x-axis shifts are greater than the specified number (32 since the standard BYOND atom is 32x32px and this is moving that atom)
			a.loc=locate(a.x+1,a.y,a.z)          //shift the mob to the right the specified number of steps
			a.x_shifts-=32                       //reset the x_shifts so this can be repeated
			a.pixel_x=0                          //adjust the icon's x value pixel offset
		if(a.x_shifts<=-32)                      //this next chunk is the same as above but for negative movement on the x-axis
			a.loc=locate(a.x-1,a.y,a.z)
			a.x_shifts+=32
			a.pixel_x=0
		if(a.y_shifts>=32)                       //if the y-axis shifts are greater than the specified number
			a.loc=locate(a.x,a.y+1,a.z)          //shift the mob up
			a.y_shifts-=32                       //reset y-shifts
			a.pixel_y=0                          //adjust the icon's y value pixel offset
		if(a.y_shifts<=-32)                      //this next chunk is the same as above but for negative movement on the y-axis
			a.loc=locate(a.x,a.y-1,a.z)
			a.y_shifts+=32
			a.pixel_y=0

	C_Camera_Handling(mob/m,camadjust_x,camadjust_y)
		if(m.client)                             //only messes with the camera if there's a client attatched to the mob
			m.client.pixel_x+=camadjust_x
			m.client.pixel_y+=camadjust_y
			if(m.x_shifts>=32||m.x_shifts<=-32)
				m.client.pixel_x=0
			if(m.y_shifts>=32||m.y_shifts<=-32)
				m.client.pixel_y=0
