var/list
	allowed_tags
	allowed_attributes

client/verb
	Say(t as text)
		src << "<strong>Proc Called:</strong> censor_html([_html_tag_encode(t)],\
		allowed_tags = list(\"[_hc_string_replace(list2params(allowed_tags),"&","\",\"")]\")\
		,allowed_attributes = list(\"[_hc_string_replace(list2params(allowed_attributes),"&","\",\"")]\"))"
		src << "<strong>Text Outputted:</strong> [censor_html(t,allowed_tags,allowed_attributes)]\
		\n"

	Set_Tags()
		src << browse({"
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html>
  <head>
    <style>
      body {
        background-color: #000000;
        color: #ffffff;
        font-family:Tahoma;
        font-size:large;
        }

      td {text-align: center;}
      </style>
    <title>Tag Settings</title>
  </head>
  <body>
    <form action="byond://" method="get" onSubmit="alert('Tags Set');">
      <table border="2" cellpadding="3">
        <tr>
          <th>Tag</th>
          <th>Allowed</th>
        </tr>
        <tr>
          <td>
            <label for="a">a</label>
          </td>
          <td>
            <select name="a" id="a">
              <option value="off">No</option>
              <option value="on">Yes</option>
            </select>
          </td>
        </tr>
        <tr>
          <td>
            <label for="b">b</label>
          </td>
          <td>
            <select name="b" id="b">
              <option value="off">No</option>
              <option value="on">Yes</option>
            </select>
          </td>
        </tr>
        <tr>
          <td>
            <label for="font">font</label>
          </td>
          <td>
            <select name="font" id="font">
              <option value="off">No</option>
              <option value="on">Yes</option>
            </select>
          </td>
        </tr>
        <tr>
          <td>
            <label for="i">i</label>
          </td>
          <td>
            <select name="i" id="i">
              <option value="off">No</option>
              <option value="on">Yes</option>
            </select>
          </td>
        </tr>
        <tr>
          <td colspan="2">
            <input type="submit" value="OK" />
          </td>
        </tr>
      </table>
    </form>
  </body>
</html>
"})

	Set_Attributes()
		src << browse({"
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html>
  <head>
    <style>
      body {
        background-color: #000000;
        color: #ffffff;
        font-family:Tahoma;
        font-size:large;
        }

      td {text-align: center;}
      </style>
    <title>Attribute Settings</title>
  </head>
  <body>
    <form action="byond://" method="get" onSubmit="alert('Attributes Set');">
      <table border="2" cellpadding="3">
        <tr>
          <th>Attribute</th>
          <th>Allowed</th>
        </tr>
        <tr>
          <td>
            <label for="color">color</label>
          </td>
          <td>
            <select name="color" id="color">
              <option value="off">No</option>
              <option value="on">Yes</option>
            </select>
          </td>
        </tr>
        <tr>
          <td>
            <label for="face">face</label>
          </td>
          <td>
            <select name="face" id="face">
              <option value="off">No</option>
              <option value="on">Yes</option>
            </select>
          </td>
        </tr>
        <tr>
          <td>
            <label for="size">size</label>
          </td>
          <td>
            <select name="size" id="size">
              <option value="off">No</option>
              <option value="on">Yes</option>
            </select>
          </td>
        </tr>
        <tr>
          <td>
            <label for="style">style</label>
          </td>
          <td>
            <select name="style" id="style">
              <option value="off">No</option>
              <option value="on">Yes</option>
            </select>
          </td>
        </tr>
        <tr>
          <td colspan="2">
            <input type="submit" value="OK" />
          </td>
        </tr>
      </table>
    </form>
  </body>
</html>
"})

client/Topic(href,href_list[])
	.=..()
	//Use tag_info to tell if tag info or attribute info is being sent
	var/tag_info = 0
	if(copytext(href,1,3) == "a=") tag_info = 1
	for(var/elem in href_list)
		//on
		if(href_list[elem] == "on")
			//if tag info is being sent
			if(tag_info)
				if(!allowed_tags) allowed_tags = list()
				if(!(elem in allowed_tags)) allowed_tags += elem
			//attribute info
			else
				if(!allowed_attributes) allowed_attributes = list()
				if(!(elem in allowed_attributes)) allowed_attributes += elem
		//off
		else
			//tag info being sent
			if(tag_info)
				if(allowed_tags && elem in allowed_tags) allowed_tags -= elem
			//attribute info being sent
			else
				if(allowed_attributes && elem in allowed_attributes) allowed_attributes -= elem