//Returns an assoc. list in the format, start_pos = end_pos
proc/_get_tags(t)
	ASSERT(istext(t))
	var/list/result
	var/start_pos = findtext(t,"<")
	while(start_pos && start_pos != length(t))
		var/next_start = findtext(t,"<",start_pos + 1)
		var/end_pos    = findtext(t,">",start_pos + 1)
		if(end_pos)
			if(next_start)
				if(next_start > end_pos)
					if(!result) result = list()
					result["[start_pos]"] = end_pos
				start_pos = next_start
			else
				if(!result) result = list()
				result["[start_pos]"] = end_pos
				start_pos = 0
		else start_pos = 0
	if(result && result.len) return result